unit Help;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  IniFiles, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.ComCtrls, Vcl.Menus;

const
  FORM_WIDTH_SET    = 800;
  FORM_HEIGHT_SET   = 600;

type
  TFormHelp = class(TForm)
    Memo1: TMemo;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

  private
    { Private 錾 }
    TabStops: array [0..0] of DWord;
  public
    { Public 錾 }
  end;

var
  FormHelp: TFormHelp;

implementation

uses
  CsvList;

{$R *.dfm}

procedure TFormHelp.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormHelp.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //tH[JX߂
end;

procedure TFormHelp.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormHelp.FormCreate(Sender: TObject);
var
  sStr1: String;
begin
  //Ǎ
  sStr1 := FormCsvList.StrDllFilePath + HELP_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    Memo1.Lines.LoadFromFile(sStr1);
  end
  else
  begin
    Memo1.Lines.Clear;
  end;

end;

procedure TFormHelp.FormDestroy(Sender: TObject);
begin
  //
end;

procedure TFormHelp.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormHelp.KeyPreview := TRUE;

  //ݒ
  TabStops[0] := 4*4;
  Memo1.Perform(EM_SETTABSTOPS, 1, Longint(@TabStops));
  Memo1.Invalidate;
end;


procedure TFormHelp.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if (Shift = []) and (key = VK_ESCAPE) then
  begin
    //I
    Close;
  end
  //
  else
  begin
    ;
  end;
end;

procedure TFormHelp.FormResize(Sender: TObject);
begin
  //
end;

end.

