unit Jump;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, System.UITypes, DecEdit;

type
  TFormJump = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    ButtonOk: TButton;
    ButtonCancel: TButton;
    DecEdit1: TDecEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
    procedure DecEdit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  FormJump: TFormJump;

implementation

uses
  CsvList;


{$R *.dfm}

procedure TFormJump.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //tH[JX߂
end;

procedure TFormJump.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormJump.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(FormCsvList.StrIniFileName);
  //ǂݍ
  DecEdit1.Text := IniFile.ReadString('Editor', 'Jump',  '1');
  //j
  IniFile.Free;
end;

procedure TFormJump.FormDestroy(Sender: TObject);
begin
  //;
end;

procedure TFormJump.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormJump.KeyPreview := TRUE;
  //tH[JX
  DecEdit1.SetFocus;
end;

procedure TFormJump.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end;
end;

procedure TFormJump.DecEdit1KeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
begin
  //Enter
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    //OK
    ButtonOkClick(Sender);
  end;
end;

procedure TFormJump.ButtonOkClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(FormCsvList.StrIniFileName);
  //ۑ
  IniFile.WriteString('Editor', 'Jump',  DecEdit1.Text);
  //j
  IniFile.Free;
  //
  ModalResult := mrOk;
end;

procedure TFormJump.ButtonCancelClick(Sender: TObject);
begin
  //I
  Close;
end;

end.

