unit KeyMap;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, Vcl.ComCtrls, Vcl.ExtCtrls,
  IniFiles, Vcl.StdCtrls;

const
  FORM_WIDTH_SET    = 800;
  FORM_HEIGHT_SET   = 480;

type
  TFormKeyMap = class(TForm)
    Timer1: TTimer;
    ListView1: TListView;
    Memo1: TMemo;
    Panel1: TPanel;
    ButtonSort0: TButton;
    ButtonSort1: TButton;
    ButtonCopyToClip: TButton;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SetKeySort0(Sender: TObject);
    procedure SetKeySort1(Sender: TObject);
    procedure GetKeySort1(Sender: TObject);
    procedure ButtonSort0Click(Sender: TObject);
    procedure ButtonSort1Click(Sender: TObject);
    procedure ButtonCopyToClipClick(Sender: TObject);

  private
    { Private 錾 }
    BoolFileExist: Boolean;
    StrListKeyMap: TStringList;
    StrListKeyMapClip: TStringList;
    StrListKeyMapKey0: TStringList;
    StrListKeyMapKey1: TStringList;
    StrListKeyMapKey2: TStringList;
    StrListKeyMapKey3: TStringList;
    StrListKeyMapKey4: TStringList;
    StrListKeyMapKey5: TStringList;
    StrListKeyMapKey6: TStringList;
    StrListKeyMapKey7: TStringList;
    StrListKeyMapKey8: TStringList;
  public
    { Public 錾 }
  end;

var
  FormKeyMap: TFormKeyMap;

implementation

uses
  CsvList;

{$R *.dfm}

//L[ݒŃ\[g
function CompareTab(List: TStringList; Index1, Index2: Integer): Integer;
var
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  iPos14: Integer;
  iPos15: Integer;
  iPos16: Integer;
  iPos17: Integer;
  iPos21: Integer;
  iPos22: Integer;
  iPos23: Integer;
  iPos24: Integer;
  iPos25: Integer;
  iPos26: Integer;
  iPos27: Integer;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  sStr19: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr24: String;
  sStr25: String;
  sStr26: String;
  sStr27: String;
  sStr28: String;
  sStr29: String;
begin
  //ŏ
  sStr11 := List[Index1];
  iPos11 := Pos(#09, sStr11);
  //PԖڂTABȍ~
  sStr12 := Copy(sStr11, iPos11+1, Length(sStr11));
  iPos12 := Pos(#09, sStr12);
  //QԖڂTABȍ~
  sStr13 := Copy(sStr12, iPos12+1, Length(sStr12));
  iPos13 := Pos(#09, sStr13);
  //QԖڂƂRԖڂ̊
  sStr14 := Copy(sStr13, 1, iPos13-1);

  //
  iPos14 := Pos('Shift+', sStr14);
  iPos15 := Pos('Ctrl+'  ,sStr14);
  iPos16 := Pos('Alt+'  , sStr14);
  //ݒ
  iPos17 := 1000;
  if iPos14 > 0 then
  begin
    iPos17 := iPos17 + 100;
  end;
  if iPos15 > 0 then
  begin
    iPos17 := iPos17 + 10;
  end;
  if iPos16 > 0 then
  begin
    iPos17 := iPos17 + 1;
  end;
  //u
  sStr15 := StringReplace(sStr14, 'Shift+', '', [rfReplaceAll]);
  sStr16 := StringReplace(sStr15, 'Ctrl+',  '', [rfReplaceAll]);
  sStr17 := StringReplace(sStr16, 'Alt+',   '', [rfReplaceAll]);
  sStr18 := StringReplace(sStr17, ' ',      '', [rfReplaceAll]);
  //ݒ
  sStr19 := Format('%.04d', [iPos17]) + sStr18;


  //ŏ
  sStr21 := List[Index2];
  iPos21 := Pos(#09, sStr21);
  //PԖڂTABȍ~
  sStr22 := Copy(sStr21, iPos21+1, Length(sStr21));
  iPos22 := Pos(#09, sStr22);
  //QԖڂTABȍ~
  sStr23 := Copy(sStr22, iPos22+1, Length(sStr22));
  iPos23 := Pos(#09, sStr23);
  //QԖڂƂRԖڂ̊
  sStr24 := Copy(sStr23, 1, iPos23-1);

  //
  iPos24 := Pos('Shift+', sStr24);
  iPos25 := Pos('Ctrl+' , sStr24);
  iPos26 := Pos('Alt+'  , sStr24);
  //ݒ
  iPos27 := 1000;
  if iPos24 > 0 then
  begin
    iPos27 := iPos27 + 100;
  end;
  if iPos25 > 0 then
  begin
    iPos27 := iPos27 + 10;
  end;
  if iPos26 > 0 then
  begin
    iPos27 := iPos27 + 1;
  end;
  //u
  sStr25 := StringReplace(sStr24, 'Shift+', '', [rfReplaceAll]);
  sStr26 := StringReplace(sStr25, 'Ctrl+',  '', [rfReplaceAll]);
  sStr27 := StringReplace(sStr26, 'Alt+',   '', [rfReplaceAll]);
  sStr28 := StringReplace(sStr27, ' ',      '', [rfReplaceAll]);
  //ݒ
  sStr29 := Format('%.04d', [iPos27]) + sStr28;

  //
  Result := CompareText(sStr19, sStr29);
end;

procedure TFormKeyMap.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormKeyMap.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //
end;

procedure TFormKeyMap.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormKeyMap.FormCreate(Sender: TObject);
begin
  //
  Timer1.Enabled := FALSE;
  //m
  StrListKeyMap := TStringList.Create;
  StrListKeyMapClip := TStringList.Create;
  StrListKeyMapKey0 := TStringList.Create;
  StrListKeyMapKey1 := TStringList.Create;
  StrListKeyMapKey2 := TStringList.Create;
  StrListKeyMapKey3 := TStringList.Create;
  StrListKeyMapKey4 := TStringList.Create;
  StrListKeyMapKey5 := TStringList.Create;
  StrListKeyMapKey6 := TStringList.Create;
  StrListKeyMapKey7 := TStringList.Create;
  StrListKeyMapKey8 := TStringList.Create;

end;

procedure TFormKeyMap.FormDestroy(Sender: TObject);
begin
  //j
  StrListKeyMap.Free;
  StrListKeyMapClip.Free;
  StrListKeyMapKey0.Free;
  StrListKeyMapKey1.Free;
  StrListKeyMapKey2.Free;
  StrListKeyMapKey3.Free;
  StrListKeyMapKey4.Free;
  StrListKeyMapKey5.Free;
  StrListKeyMapKey6.Free;
  StrListKeyMapKey7.Free;
  StrListKeyMapKey8.Free;

end;

procedure TFormKeyMap.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if (Shift = []) and (key = VK_ESCAPE) then
  begin
    //I
    Close;
  end;
end;

procedure TFormKeyMap.FormShow(Sender: TObject);
var
  sStr1: String;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormkeyMap.KeyPreview := TRUE;

  //ݒ
  ListView1.Columns.Add.Caption  := 'JeS';
  ListView1.Columns[0].Width := 110;
  ListView1.Columns.Add.Caption  := 'R}h';
  ListView1.Columns[1].Width := FormkeyMap.ClientWidth - 420;
  ListView1.Columns.Add.Caption  := '݂̃L[';
  ListView1.Columns[2].Width := 200;
  ListView1.Columns.Add.Caption  := '@\';
  ListView1.Columns[3].Width :=  60;
  ListView1.Columns.Add.Caption  := '';
  ListView1.Columns[4].Width :=  10;
  ListView1.ViewStyle := vsReport;
  ListView1.RowSelect := TRUE;
  ListView1.MultiSelect := FALSE;
  ListView1.Align := alClient;
  ListView1.ReadOnly := TRUE;

  //Ǎ
  sStr1 := FormCsvList.StrDllFilePath + KEYMAP_LIST;;
  if FileExists(sStr1) = TRUE then
  begin
    BoolFileExist  := TRUE;
    //Ǎ
    StrListKeyMap.LoadFromFile(sStr1);
    //\[g
    GetKeySort1(Sender);
  end
  else
  begin
    BoolFileExist  := FALSE;
  end;

  //\
  SetKeySort0(Sender);

  //\
  if BoolFileExist = FALSE then
  begin
    Timer1.Enabled := TRUE;
  end;
end;

procedure TFormKeyMap.FormResize(Sender: TObject);
begin
  ListView1.Columns[0].Width := 110;
  ListView1.Columns[1].Width := FormkeyMap.ClientWidth - 420;
  ListView1.Columns[2].Width := 200;
  ListView1.Columns[3].Width :=  60;
  ListView1.Columns[4].Width :=  10;
end;

procedure TFormKeyMap.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := FALSE;
  showmessage('L[{[hݒ̃t@C݂܂ł');
end;

procedure TFormKeyMap.SetKeySort0(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  nItem: TListItem;
begin
  //\
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  //ݒ
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow1].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow1].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow1].SubItems.Add(sStr17);
  end;
  //XV
  ListView1.Items.EndUpdate;

  //ݒ
  if ListView1.Items.Count > 0 then
  begin
    ListView1.ItemIndex := 0;
    ListView1.Selected := ListView1.Items[0];
    ListView1.ItemFocused := ListView1.Items[0];
  end;

  //ݒ
  StrListKeyMapClip.Assign(StrListKeyMap);
end;

procedure TFormKeyMap.SetKeySort1(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iRow2: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  nItem: TListItem;
begin
  //\
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  //
  iRow2 := 0;
  StrListKeyMapClip.Clear;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey1.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey1.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey2.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey2.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey3.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey3.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey4.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey4.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey5.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey5.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey6.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey6.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey7.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey7.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey8.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey8.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey0.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey0.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //XV
  ListView1.Items.EndUpdate;

  //ݒ
  if ListView1.Items.Count > 0 then
  begin
    ListView1.ItemIndex := 0;
    ListView1.Selected := ListView1.Items[0];
    ListView1.ItemFocused := ListView1.Items[0];
  end;

end;

procedure TFormKeyMap.GetKeySort1(Sender: TObject);
var
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  iPos14: Integer;
  iPos15: Integer;
  iPos16: Integer;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
begin
  //ݒ
  StrListKeyMapKey0.Clear;
  StrListKeyMapKey1.Clear;
  StrListKeyMapKey2.Clear;
  StrListKeyMapKey3.Clear;
  StrListKeyMapKey4.Clear;
  StrListKeyMapKey5.Clear;
  StrListKeyMapKey6.Clear;
  StrListKeyMapKey7.Clear;

  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //ŏ
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#09, sStr11);
    //PԖڂTABȍ~
    sStr12 := Copy(sStr11, iPos11+1, Length(sStr11));
    iPos12 := Pos(#09, sStr12);
    //QԖڂTABȍ~
    sStr13 := Copy(sStr12, iPos12+1, Length(sStr12));
    iPos13 := Pos(#09, sStr13);
    //QԖڂƂRԖڂ̊
    sStr14 := Copy(sStr13, 1, iPos13-1);

    //
    iPos14 := Pos('Shift+', sStr14);
    iPos15 := Pos('Ctrl+'  ,sStr14);
    iPos16 := Pos('Alt+'  , sStr14);

    //
    if sStr14 = '' then                                         //
    begin
      StrListKeyMapKey0.Add(sStr11);
    end
    else if (iPos14 = 0) and (iPos15 = 0) and (iPos16 = 0) then //
    begin
      StrListKeyMapKey1.Add(sStr11);
    end
    else if (iPos14 > 0) and (iPos15 = 0) and (iPos16 = 0) then  //shift
    begin
      StrListKeyMapKey2.Add(sStr11);
    end
    else if (iPos14 > 0) and (iPos15 > 0) and (iPos16 = 0) then  //shift Ctrl
    begin
      StrListKeyMapKey3.Add(sStr11);
    end
    else if (iPos14 > 0) and (iPos15 = 0) and (iPos16 > 0) then  //shift alt
    begin
      StrListKeyMapKey4.Add(sStr11);
    end
    else if (iPos14 > 0) and (iPos15 > 0) and (iPos16 > 0) then  //shift ctl alt
    begin
      StrListKeyMapKey5.Add(sStr11);
    end
    else if (iPos14 = 0) and (iPos15 > 0) and (iPos16 = 0) then  //ctrl
    begin
      StrListKeyMapKey6.Add(sStr11);
    end
    else if (iPos14 = 0) and (iPos15 > 0) and (iPos16 > 0) then  //ctrl alt
    begin
      StrListKeyMapKey7.Add(sStr11);
    end
    else if (iPos14 = 0) and (iPos15 = 0) and (iPos16 > 0) then //alt
    begin
      StrListKeyMapKey8.Add(sStr11);
    end
    else
    begin
      //
    end;
  end;

  //\[g
  StrListKeyMapKey1.CustomSort(CompareTab);
  StrListKeyMapKey2.CustomSort(CompareTab);
  StrListKeyMapKey3.CustomSort(CompareTab);
  StrListKeyMapKey4.CustomSort(CompareTab);
  StrListKeyMapKey5.CustomSort(CompareTab);
  StrListKeyMapKey6.CustomSort(CompareTab);
  StrListKeyMapKey7.CustomSort(CompareTab);
  StrListKeyMapKey8.CustomSort(CompareTab);
end;

procedure TFormKeyMap.ButtonCopyToClipClick(Sender: TObject);
begin
  Memo1.Lines.Assign(StrListKeyMapClip);
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
end;

procedure TFormKeyMap.ButtonSort0Click(Sender: TObject);
begin
  SetKeySort0(Sender);
end;

procedure TFormKeyMap.ButtonSort1Click(Sender: TObject);
begin
  SetKeySort1(Sender);
end;

end.
